Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | List of all members
Botan::SIV_Mode Class Referenceabstract

`#include <siv.h>`

Inheritance diagram for Botan::SIV_Mode:

## Public Member Functions
bool | authenticated () const override
void | clear () override
size_t | default_nonce_length () const override
virtual void | finish (secure_vector< uint8_t > &final_block, size_t offset=0)=0
Key_Length_Specification | key_spec () const override
virtual size_t | minimum_final_size () const =0
std::string | name () const override
virtual size_t | output_length (size_t input_length) const =0
size_t | process (uint8_t buf[], size_t size) override
virtual std::string | provider () const
void | reset () override
template<typename Alloc >
void | set_ad (const std::vector< uint8_t, Alloc > &ad)
void | set_associated_data (const uint8_t ad[], size_t ad_len) override
void | set_associated_data_n (size_t n, const uint8_t ad[], size_t ad_len)
template<typename Alloc >
void | set_associated_data_vec (const std::vector< uint8_t, Alloc > &ad)
template<typename Alloc >
void | set_key (const std::vector< uint8_t, Alloc > &key)
void | set_key (const SymmetricKey &key)
void | set_key (const uint8_t key[], size_t length)
template<typename Alloc >
void | start (const std::vector< uint8_t, Alloc > &nonce)
void | start (const uint8_t nonce[], size_t nonce_len)
void | start ()
size_t | tag_size () const override
void | update (secure_vector< uint8_t > &buffer, size_t offset=0)
size_t | update_granularity () const override
bool | valid_keylength (size_t length) const
bool | valid_nonce_length (size_t) const override

## Protected Member Functions
StreamCipher & | ctr ()
secure_vector< uint8_t > & | msg_buf ()
secure_vector< uint8_t > | S2V (const uint8_t text[], size_t text_len)
void | set_ctr_iv (secure_vector< uint8_t > V)
| SIV_Mode (BlockCipher *cipher)

## Detailed Description

Base class for SIV encryption and decryption (

See also
  RFC 5297)

Definition at line 22 of file siv.h.

## Constructor & Destructor Documentation

Botan::SIV_Mode::SIV_Mode | ( | BlockCipher * | cipher | ) |
| explicit protected

Definition at line 16 of file siv.cpp.

References Botan::BlockCipher::block_size().

16 :
17 m_name(cipher->name() + "/SIV"),
18 m_ctr(new CTR_BE(cipher->clone())),
19 m_cmac(new CMAC(cipher))
20 {
21 if(cipher->block_size() != 16)
22 throw Invalid_Argument("SIV requires a 128 bit block cipher");
23 }

## Member Function Documentation

bool Botan::AEAD_Mode::authenticated | ( |  | ) | const
| inline override virtual inherited

Returns
  true iff this mode provides authentication as well as confidentiality.

Reimplemented from Botan::Cipher_Mode.

Definition at line 25 of file aead.h.

25 { return true; }

void Botan::SIV_Mode::clear | ( |  | ) |
| override virtual

Zeroise all state See also reset_msg()

Implements Botan::Cipher_Mode.

Definition at line 25 of file siv.cpp.

References reset().

26 {
27 m_ctr->clear();
28 m_cmac->clear();
29 reset();
30 }
Botan::SIV_Mode::reset
void reset() override
Definition: siv.cpp:32

StreamCipher& Botan::SIV_Mode::ctr | ( |  | ) |
| inline protected

Definition at line 57 of file siv.h.

Referenced by Botan::SIV_Encryption::finish(), Botan::SIV_Decryption::finish(), and set_ctr_iv().

57 { return *m_ctr; }

size_t Botan::AEAD_Mode::default_nonce_length | ( |  | ) | const
| inline override virtual inherited

Returns
  default AEAD nonce size (a commonly supported value among AEAD modes, and large enough that random collisions are unlikely)

Implements Botan::Cipher_Mode.

Reimplemented in Botan::TLS::TLS_CBC_HMAC_AEAD_Mode, and Botan::CCM_Mode.

Definition at line 75 of file aead.h.

75 { return 12; }

virtual void Botan::Cipher_Mode::finish | ( | secure_vector< uint8_t > & | final_block,
|  | size_t | offset = `0`
| ) |  |
| pure virtual inherited

Complete processing of a message.

Parameters

  final_block | in/out parameter which must be at least minimum_final_size() bytes, and will be set to any final output
  offset | an offset into final_block to begin processing

Implemented in Botan::TLS::TLS_CBC_HMAC_AEAD_Decryption, Botan::CTS_Decryption, Botan::TLS::TLS_CBC_HMAC_AEAD_Encryption, Botan::CBC_Decryption, Botan::OCB_Decryption, Botan::CCM_Decryption, Botan::EAX_Decryption, Botan::GCM_Decryption, Botan::SIV_Decryption, Botan::CTS_Encryption, Botan::CFB_Decryption, Botan::ChaCha20Poly1305_Decryption, Botan::OCB_Encryption, Botan::CCM_Encryption, Botan::SIV_Encryption, Botan::XTS_Decryption, Botan::EAX_Encryption, Botan::GCM_Encryption, Botan::CBC_Encryption, Botan::CFB_Encryption, Botan::ChaCha20Poly1305_Encryption, Botan::XTS_Encryption, and Botan::Stream_Cipher_Mode.

Referenced by botan_cipher_update(), and Botan::TLS::write_record().

Key_Length_Specification Botan::SIV_Mode::key_spec | ( |  | ) | const
| override virtual

Returns
  object describing limits on key size

Implements Botan::Cipher_Mode.

Definition at line 60 of file siv.cpp.

61 {
62 return m_cmac->key_spec().multiple(2);
63 }

virtual size_t Botan::Cipher_Mode::minimum_final_size | ( |  | ) | const
| pure virtual inherited

Returns
  required minimium size to finalize() - may be any length larger than this.

Implemented in Botan::TLS::TLS_CBC_HMAC_AEAD_Decryption, Botan::CTS_Decryption, Botan::TLS::TLS_CBC_HMAC_AEAD_Encryption, Botan::CBC_Decryption, Botan::CCM_Decryption, Botan::OCB_Decryption, Botan::SIV_Decryption, Botan::EAX_Decryption, Botan::GCM_Decryption, Botan::CTS_Encryption, Botan::CCM_Encryption, Botan::SIV_Encryption, Botan::ChaCha20Poly1305_Decryption, Botan::OCB_Encryption, Botan::EAX_Encryption, Botan::CBC_Encryption, Botan::GCM_Encryption, Botan::ChaCha20Poly1305_Encryption, Botan::Stream_Cipher_Mode, Botan::CFB_Mode, and Botan::XTS_Mode.

Referenced by botan_cipher_update().

secure_vector<uint8_t>& Botan::SIV_Mode::msg_buf | ( |  | ) |
| inline protected

Definition at line 61 of file siv.h.

Referenced by Botan::SIV_Encryption::finish(), and Botan::SIV_Decryption::finish().

61 { return m_msg_buf; }

std::string Botan::SIV_Mode::name | ( |  | ) | const
| override virtual

Implements Botan::Cipher_Mode.

Definition at line 39 of file siv.cpp.

40 {
41 return m_name;
42 }

virtual size_t Botan::Cipher_Mode::output_length | ( | size_t | input_length | ) | const
| pure virtual inherited

Returns the size of the output if this transform is used to process a message with input_length bytes. Will throw if unable to give a precise answer.

Implemented in Botan::TLS::TLS_CBC_HMAC_AEAD_Decryption, Botan::TLS::TLS_CBC_HMAC_AEAD_Encryption, Botan::CBC_Decryption, Botan::CCM_Decryption, Botan::OCB_Decryption, Botan::SIV_Decryption, Botan::EAX_Decryption, Botan::GCM_Decryption, Botan::CTS_Encryption, Botan::CCM_Encryption, Botan::SIV_Encryption, Botan::XTS_Decryption, Botan::OCB_Encryption, Botan::ChaCha20Poly1305_Decryption, Botan::CBC_Encryption, Botan::EAX_Encryption, Botan::GCM_Encryption, Botan::XTS_Encryption, Botan::ChaCha20Poly1305_Encryption, Botan::Stream_Cipher_Mode, and Botan::CFB_Mode.

Referenced by Botan::TLS::write_record().

size_t Botan::SIV_Mode::process | ( | uint8_t | msg[],
|  | size_t | msg_len
| ) |  |
| override virtual

Process message blocks

Input must be a multiple of update_granularity

Processes msg in place and returns bytes written. Normally this will be either msg_len (indicating the entire message was processed) or for certain AEAD modes zero (indicating that the mode requires the entire message be processed in one pass).

Parameters

  msg | the message to be processed
  msg_len | length of the message in bytes

Implements Botan::Cipher_Mode.

Definition at line 94 of file siv.cpp.

95 {
96 // all output is saved for processing in finish
97 m_msg_buf.insert(m_msg_buf.end(), buf, buf + sz);
98 return 0;
99 }

virtual std::string Botan::Cipher_Mode::provider | ( |  | ) | const
| inline virtual inherited

Returns
  provider information about this implementation. Default is "base", might also return "sse2", "avx2", "openssl", or some other arbitrary string.

Reimplemented in Botan::GCM_Mode.

Definition at line 202 of file cipher_mode.h.

202 { return "base"; }

void Botan::SIV_Mode::reset | ( |  | ) |
| override virtual

Resets just the message specific state and allows encrypting again under the existing key

Implements Botan::Cipher_Mode.

Definition at line 32 of file siv.cpp.

Referenced by clear().

33 {
34 m_nonce.clear();
35 m_msg_buf.clear();
36 m_ad_macs.clear();
37 }

secure_vector< uint8_t > Botan::SIV_Mode::S2V | ( | const uint8_t | text[],
|  | size_t | text_len
| ) |  |
| protected

Definition at line 101 of file siv.cpp.

References Botan::CMAC::poly_double(), and Botan::xor_buf().

Referenced by Botan::SIV_Encryption::finish(), and Botan::SIV_Decryption::finish().

102 {
103 const uint8_t zero[16] = { 0 };
104
105 secure_vector<uint8_t> V = m_cmac->process(zero, 16);
106
107 for(size_t i = 0; i != m_ad_macs.size(); ++i)
108 {
109 V = CMAC::poly_double(V);
110 V ^= m_ad_macs[i];
111 }
112
113 if(m_nonce.size())
114 {
115 V = CMAC::poly_double(V);
116 V ^= m_nonce;
117 }
118
119 if(text_len < 16)
120 {
121 V = CMAC::poly_double(V);
122 xor_buf(V.data(), text, text_len);
123 V[text_len] ^= 0x80;
124 return m_cmac->process(V);
125 }
126
127 m_cmac->update(text, text_len - 16);
128 xor_buf(V.data(), &text[text_len - 16], 16);
129 m_cmac->update(V);
130
131 return m_cmac->final();
132 }
Botan::xor_buf
void xor_buf(T out[], const T in[], size_t length)
Definition: mem_ops.h:115
Botan::CMAC::poly_double
static secure_vector< uint8_t > poly_double(const secure_vector< uint8_t > &in)
Definition: cmac.cpp:15
template<typename Alloc >

void Botan::AEAD_Mode::set_ad | ( | const std::vector< uint8_t, Alloc > & | ad | ) |
| inline inherited

Set associated data that is not included in the ciphertext but that should be authenticated. Must be called after set_key and before start.

See set_associated_data().

Parameters

  ad | the associated data

Definition at line 66 of file aead.h.

Referenced by Botan::TLS::write_record().

67 {
68 set_associated_data(ad.data(), ad.size());
69 }
Botan::AEAD_Mode::set_associated_data
virtual void set_associated_data(const uint8_t ad[], size_t ad_len)=0

void Botan::SIV_Mode::set_associated_data | ( | const uint8_t | ad[],
|  | size_t | ad_len
| ) |  |
| inline override virtual

Set associated data that is not included in the ciphertext but that should be authenticated. Must be called after set_key and before start.

Unless reset by another call, the associated data is kept between messages. Thus, if the AD does not change, calling once (after set_key) is the optimum.

Parameters

  ad | the associated data
  ad_len | length of add in bytes

Implements Botan::AEAD_Mode.

Definition at line 35 of file siv.h.

36 {
37 set_associated_data_n(0, ad, ad_len);
38 }
Botan::SIV_Mode::set_associated_data_n
void set_associated_data_n(size_t n, const uint8_t ad[], size_t ad_len)
Definition: siv.cpp:73

void Botan::SIV_Mode::set_associated_data_n | ( | size_t | n,
|  | const uint8_t | ad[],
|  | size_t | ad_len
| ) |  |

Sets the nth element of the vector of associated data

Parameters

  n | index into the AD vector
  ad | associated data
  ad_len | length of associated data in bytes

Definition at line 73 of file siv.cpp.

74 {
75 if(n >= m_ad_macs.size())
76 m_ad_macs.resize(n+1);
77
78 m_ad_macs[n] = m_cmac->process(ad, length);
79 }
template<typename Alloc >

void Botan::AEAD_Mode::set_associated_data_vec | ( | const std::vector< uint8_t, Alloc > & | ad | ) |
| inline inherited

Set associated data that is not included in the ciphertext but that should be authenticated. Must be called after set_key and before start.

See set_associated_data().

Parameters

  ad | the associated data

Definition at line 51 of file aead.h.

52 {
53 set_associated_data(ad.data(), ad.size());
54 }
Botan::AEAD_Mode::set_associated_data
virtual void set_associated_data(const uint8_t ad[], size_t ad_len)=0

void Botan::SIV_Mode::set_ctr_iv | ( | secure_vector< uint8_t > | V | ) |
| protected

Definition at line 134 of file siv.cpp.

References ctr(), and Botan::StreamCipher::set_iv().

Referenced by Botan::SIV_Encryption::finish(), and Botan::SIV_Decryption::finish().

135 {
136 V[8] &= 0x7F;
137 V[12] &= 0x7F;
138
139 ctr().set_iv(V.data(), V.size());
140 }
Botan::SIV_Mode::ctr
StreamCipher & ctr()
Definition: siv.h:57
Botan::StreamCipher::set_iv
virtual void set_iv(const uint8_t iv[], size_t iv_len)=0
template<typename Alloc >

void Botan::Cipher_Mode::set_key | ( | const std::vector< uint8_t, Alloc > & | key | ) |
| inline inherited

Set the symmetric key of this transform

Parameters

  key | contains the key material

Definition at line 172 of file cipher_mode.h.

Referenced by botan_cipher_set_key().

173 {
174 set_key(key.data(), key.size());
175 }
Botan::Cipher_Mode::set_key
void set_key(const std::vector< uint8_t, Alloc > &key)
Definition: cipher_mode.h:172

void Botan::Cipher_Mode::set_key | ( | const SymmetricKey & | key | ) |
| inline inherited

Set the symmetric key of this transform

Parameters

  key | contains the key material

Definition at line 181 of file cipher_mode.h.

References Botan::OctetString::begin(), and Botan::OctetString::length().

182 {
183 set_key(key.begin(), key.length());
184 }
Botan::Cipher_Mode::set_key
void set_key(const std::vector< uint8_t, Alloc > &key)
Definition: cipher_mode.h:172

void Botan::Cipher_Mode::set_key | ( | const uint8_t | key[],
|  | size_t | length
| ) |  |
| inline inherited

Set the symmetric key of this transform

Parameters

  key | contains the key material
  length | in bytes of key param

Definition at line 191 of file cipher_mode.h.

192 {
193 if(!valid_keylength(length))
194 throw Invalid_Key_Length(name(), length);
195 key_schedule(key, length);
196 }
Botan::Cipher_Mode::name
virtual std::string name() const =0
Botan::Cipher_Mode::valid_keylength
bool valid_keylength(size_t length) const
Definition: cipher_mode.h:162
template<typename Alloc >

void Botan::Cipher_Mode::start | ( | const std::vector< uint8_t, Alloc > & | nonce | ) |
| inline inherited

Begin processing a message.

Parameters

  nonce | the per message nonce

Definition at line 38 of file cipher_mode.h.

Referenced by botan_cipher_start(), and Botan::TLS::write_record().

39 {
40 start_msg(nonce.data(), nonce.size());
41 }
Botan::Cipher_Mode::start_msg
virtual void start_msg(const uint8_t nonce[], size_t nonce_len)=0

void Botan::Cipher_Mode::start | ( | const uint8_t | nonce[],
|  | size_t | nonce_len
| ) |  |
| inline inherited

Begin processing a message.

Parameters

  nonce | the per message nonce
  nonce_len | length of nonce

Definition at line 48 of file cipher_mode.h.

49 {
50 start_msg(nonce, nonce_len);
51 }
Botan::Cipher_Mode::start_msg
virtual void start_msg(const uint8_t nonce[], size_t nonce_len)=0

void Botan::Cipher_Mode::start | ( |  | ) |
| inline inherited

Begin processing a message.

Definition at line 56 of file cipher_mode.h.

57 {
58 return start_msg(nullptr, 0);
59 }
Botan::Cipher_Mode::start_msg
virtual void start_msg(const uint8_t nonce[], size_t nonce_len)=0

size_t Botan::SIV_Mode::tag_size | ( |  | ) | const
| inline override virtual

Returns
  the size of the authentication tag used (in bytes)

Reimplemented from Botan::Cipher_Mode.

Definition at line 52 of file siv.h.

Referenced by Botan::SIV_Decryption::finish().

52 { return 16; }

void Botan::Cipher_Mode::update | ( | secure_vector< uint8_t > & | buffer,
|  | size_t | offset = `0`
| ) |  |
| inline inherited

Process some data. Input must be in size update_granularity() uint8_t blocks.

Parameters

  buffer | in/out parameter which will possibly be resized
  offset | an offset into blocks to begin processing

Definition at line 81 of file cipher_mode.h.

References BOTAN_ASSERT.

Referenced by botan_cipher_update(), Botan::XTS_Encryption::finish(), Botan::ChaCha20Poly1305_Encryption::finish(), Botan::CBC_Encryption::finish(), Botan::CFB_Encryption::finish(), Botan::EAX_Encryption::finish(), Botan::XTS_Decryption::finish(), Botan::CFB_Decryption::finish(), Botan::CTS_Encryption::finish(), Botan::CBC_Decryption::finish(), Botan::TLS::TLS_CBC_HMAC_AEAD_Encryption::finish(), Botan::CTS_Decryption::finish(), and Botan::TLS::TLS_CBC_HMAC_AEAD_Decryption::finish().

82 {
83 BOTAN_ASSERT(buffer.size() >= offset, "Offset ok");
84 uint8_t* buf = buffer.data() + offset;
85 const size_t buf_size = buffer.size() - offset;
86
87 const size_t written = process(buf, buf_size);
88 buffer.resize(offset + written);
89 }
BOTAN_ASSERT
#define BOTAN_ASSERT(expr, assertion_made)
Definition: assert.h:27
Botan::Cipher_Mode::process
virtual size_t process(uint8_t msg[], size_t msg_len)=0

size_t Botan::SIV_Mode::update_granularity | ( |  | ) | const
| override virtual

Returns
  size of required blocks to update

Implements Botan::Cipher_Mode.

Definition at line 49 of file siv.cpp.

50 {
51 /*
52 This value does not particularly matter as regardless SIV_Mode::update
53 buffers all input, so in theory this could be 1. However as for instance
54 Transform_Filter creates update_granularity() uint8_t buffers, use a
55 somewhat large size to avoid bouncing on a tiny buffer.
56 */
57 return 128;
58 }

bool Botan::Cipher_Mode::valid_keylength | ( | size_t | length | ) | const
| inline inherited

Check whether a given key length is valid for this algorithm.

Parameters

  length | the key length to be checked.

Returns
  true if the key length is valid.

Definition at line 162 of file cipher_mode.h.

163 {
164 return key_spec().valid_keylength(length);
165 }
Botan::Key_Length_Specification::valid_keylength
bool valid_keylength(size_t length) const
Definition: key_spec.h:51
Botan::Cipher_Mode::key_spec
virtual Key_Length_Specification key_spec() const =0

bool Botan::SIV_Mode::valid_nonce_length | ( | size_t | nonce_len | ) | const
| override virtual

Returns
  true iff nonce_len is a valid length for the nonce

Implements Botan::Cipher_Mode.

Definition at line 44 of file siv.cpp.

45 {
46 return true;
47 }

The documentation for this class was generated from the following files:

- src/lib/modes/aead/siv/siv.h
- src/lib/modes/aead/siv/siv.cpp